Home | History | Annotate | Download | only in move
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test03} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST02***************"
     29 tst_resm TINFO "move: shared subtree to slave parent."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of move/test03 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 	"${FS_BIND_ROOT}/bin/makedir" share dir
     44 	"${FS_BIND_ROOT}/bin/makedir" share parent2
     45 	"${FS_BIND_ROOT}/bin/makedir" share share1
     46 	"${FS_BIND_ROOT}/bin/makedir" share share2
     47 
     48 	mount --bind dir share1
     49 	mount --bind share2 parent2
     50 	mkdir dir/grandchild
     51 	mkdir parent2/child2
     52 	"${FS_BIND_ROOT}/bin/makedir" slave parent2
     53 
     54 	mount --move dir parent2/child2
     55 
     56 	mount --bind "$disk1" parent2/child2/grandchild
     57 	check parent2/child2/grandchild share1/grandchild
     58 	check -n dir/grandchild parent2/child2/grandchild
     59 	check -n share2/child2/grandchild parent2/child2/grandchild
     60 
     61 	mount --bind "$disk2" share1/grandchild/a
     62 
     63 	check parent2/child2/grandchild/a share1/grandchild/a
     64 
     65 	break
     66 done
     67 trap 'ERR=$? ; tst_resm TWARN "move/test03: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     68 if [ -n "${ERR_MSG}" ]; then
     69 	tst_resm TWARN "move/test03: ${ERR_MSG}"
     70 	ERR_MSG=""
     71 	result=$ERR
     72 fi
     73 trap '' ERR
     74 {
     75 	umount share1/grandchild/a
     76 	umount parent2/child2/grandchild
     77 	umount parent2/child2 # if move succeeded
     78 	umount dir # if move failed
     79 	umount parent2
     80 	umount share1
     81 	umount share2
     82 	umount share1
     83 	umount parent2
     84 	umount dir
     85 
     86 	rm -rf dir parent* share*
     87 	cleanup
     88 } >& /dev/null
     89 if [ $result -ne 0 ]
     90 then
     91 	tst_resm TFAIL "move/test03: FAILED: move: shared subtree to slave parent."
     92 	exit 1
     93 else
     94 	tst_resm TPASS "move/test03: PASSED"
     95 	exit 0
     96 fi
     97 tst_exit
     98